﻿#include <mutex>

#define DECLARE_SINGLETON(classname_type)     \
  public:                                     \
	classname_type();

template <class MessageT>
class ReceiverManager
{
public:
	~ReceiverManager() { }

private:
	MessageT receiver_map_;
	DECLARE_SINGLETON(ReceiverManager<MessageT>)
};

template <typename MessageT>
ReceiverManager<MessageT>::ReceiverManager(){}

int main()
{
	auto m = ReceiverManager<int>();
	return 0;
}